//! @file usb_descriptors.h,v
//!
//! 쌠 (c) 2004 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief USBʎq
//!
//!  ̧ق͋Lqq\ʂĉpBɎʂUSBҰ܂݂܂B
//!
//! @version 1.9 at90usb128-demo-mouse-1_0_3 $Id: usb_descriptors.h,v 1.9 2006/07/27 07:00:33 rletendu Exp $
//!
//! @todo
//! @bug

#ifndef _USB_USERCONFIG_H_
#define _USB_USERCONFIG_H_

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "modules/usb/device_chap9/usb_standard_request.h"
#include "conf_usb.h"

//_____ ϸ ________________________________________________________________

#define Usb_get_dev_desc_pointer()	(&(usb_dev_desc.bLength))
#define Usb_get_dev_desc_length()	(sizeof (usb_dev_desc))
#define Usb_get_conf_desc_pointer()	(&(usb_conf_desc.cfg_mouse.bLength))
#define Usb_get_conf_desc_length()	(sizeof (usb_conf_desc))

//_____ USB` ____________________________________________________________

// USBuLqq
#define USB_SPECIFICATION			0x0200
#define DEVICE_CLASS				0		// e`Ԑݒ͂ꎩg̸׽܂B
#define DEVICE_SUB_CLASS			0		// e`Ԑݒ͂ꎩg̕׽܂B
#define DEVICE_PROTOCOL				0		// e`Ԑݒ͂ꎩg̋K܂B
#if (USB_LOW_SPEED_DEVICE==ENABLE)
#define EP_CONTROL_LENGTH			8
#else
#define EP_CONTROL_LENGTH			64
#endif
#define VENDOR_ID					0x03EB	// ATMEL̋ID=$03EB
#define PRODUCT_ID					0x201C
#define RELEASE_NUMBER				0x1000
#define MAN_INDEX					0x01
#define PROD_INDEX					0x02
#define SN_INDEX					0x03
#define NB_CONFIGURATION			1

// HIDϳ`Ԑݒ
#define NB_INTERFACE				1
#define CONF_NB						1
#define CONF_INDEX					0
#define CONF_ATTRIBUTES				USB_CONFIG_SELFPOWERED
#define MAX_POWER					50		// 100mA

// USBϳ̪Lqq
#define INTERFACE_NB_MOUSE			0
#define ALTERNATE_MOUSE				0
#define NB_ENDPOINT_MOUSE			1
#define INTERFACE_CLASS_MOUSE		0x03	// HID׽
#define INTERFACE_SUB_CLASS_MOUSE	0x00	// ׽Ȃ
#define INTERFACE_PROTOCOL_MOUSE	0x02	// ϳ
#define INTERFACE_INDEX_MOUSE		0

#define SELF_POWERED				1
#define DEVICE_STATUS				SELF_POWERED
#define INTERFACE_STATUS			0x00	// TBD

#define LANG_ID						0x00

// USB߲1LqqFS
#define ENDPOINT_NB_1				(EP_MOUSE_IN | 0x80)
#define EP_ATTRIBUTES_1				0x03	// =0x02,荞=0x03
#define EP_IN_LENGTH_1				8
#define EP_SIZE_1					EP_IN_LENGTH_1
#define EP_INTERVAL_1				0x02	// νĂ̊荞߰ݸފԊu

/* HIDL */
#define HID							0x21
#define REPORT						0x22
#define SET_REPORT					0x02

#define HID_DESCRIPTOR				0x21
#define HID_BDC						0x1001
#define HID_COUNTRY_CODE			0x00
#define HID_CLASS_DESC_NB			0x01
#define HID_DESCRIPTOR_TYPE			0x22

#define USB_MN_LENGTH				5
#define USB_MANUFACTURER_NAME \
{
	Usb_unicode('A'), \
	Usb_unicode('T'), \
	Usb_unicode('M'), \
	Usb_unicode('E'), \
	Usb_unicode('L') \
}

#define USB_PN_LENGTH				18
#define USB_PRODUCT_NAME \
{
	Usb_unicode('A'), \
	Usb_unicode('V'), \
	Usb_unicode('R'), \
	Usb_unicode(' '), \
	Usb_unicode('U'), \
	Usb_unicode('S'), \
	Usb_unicode('B'), \
	Usb_unicode(' '), \
	Usb_unicode('M'), \
	Usb_unicode('O'), \
	Usb_unicode('U'), \
	Usb_unicode('S'), \
	Usb_unicode('E'), \
	Usb_unicode(' '), \
	Usb_unicode('D'), \
	Usb_unicode('E'), \
	Usb_unicode('M'), \
	Usb_unicode('O') \
}

#define USB_SN_LENGTH				0x05
#define USB_SERIAL_NUMBER \
{
	Usb_unicode('1'), \
	Usb_unicode('.'), \
	Usb_unicode('0'), \
	Usb_unicode('.'), \
	Usb_unicode('0') \
}

#define LANGUAGE_ID					0x0409

//! USBv
typedef struct
{
	U8	bmRequestType;						//!< v̓
	U8	bRequest;							//!< w肷v
	U16	wValue;								//!< vɏ]ĕω̈
	U16	wIndex;								//!< vɏ]ĕω̈
	U16	wLength;							//!< ް̏ꍇ͓]޲Đ
} S_UsbRequest;

//! USBuLqq
typedef struct
{
	U8	bLength;							//!< ޲Ăł̂̋Lqq̑傫
	U8	bDescriptorType;					//!< uLqq`
	U16	bscUSB;								//!< Jdl2i10il
	U8	bDeviceClass;						//!< USBɂĊ蓖Ăꂽ׽
	U8	bDeviceSubClass;					//!< USBɂĊ蓖Ăꂽ׽
	U8	bDeviceProtocol;					//!< USBɂĊ蓖ĂꂽK񕄍
	U8	bMaxPacketSize0;					//!< EP0ɑ΂ő߹ėe
	U16	idVendor;							//!< ID(ATMEL=0x03EB)
	U16	idProduct;							//!< Ǝ҂ɂĊ蓖ĂꂽiID
	U16	bcdDevice;							//!< uJԍ
	U8	iManufacturer;						//!< ƎҕLqq̎wW
	U8	iProduct;							//!< iLqq̎wW
	U8	iSerialNumber;						//!< ʔԕLqq̎wW
	U8	bNumConfigurations;					//!< \Ȍ`Ԑݒ萔
} S_usb_device_descriptor;

//! USB`ԐݒLqq
typedef struct
{
	U8	bLength;							//!< ޲Ăł̂̋Lqq̑傫
	U8	bDescriptorType;					//!< `ԐݒLqq`
	U16	wTotalLength;						//!< Ԃް̍v
	U8	bNumInterfaces;						//!< ̌`Ԑݒɑ΂̪
	U8	bConfigurationValue;				//!< SetConfigurationvɑ΂l
	U8	iConfiguration;						//!< Lqq̎wW
	U8	bmAttibutes;						//!< `Ԑݒ
	U8	MaxPower;							//!< őd
} S_usb_configuration_descriptor;

//! USB̪Lqq
typedef struct
{
	U8	bLength;							//!< ޲Ăł̂̋Lqq̑傫
	U8	bDescriptorType;					//!< ̪Lqq`
	U8	bInterfaceNumber;					//!< ̪
	U8	bAlternateSetting;					//!< ֐ݒI邽߂̒l
	U8	bNumEndpoints;						//!< EP0߲(EP)
	U8	bInterfaceClass;					//!< USBɂĊ蓖Ăꂽ׽
	U8	bInterfaceSubClass;					//!< USBɂĊ蓖Ăꂽ׽
	U8	bInterfaceProtocol;					//!< USBɂĊ蓖ĂꂽK񕄍
	U8	iInterface;							//!< Lqq̎wW
} S_usb_interface_descriptor;

//! USB߲ċLqq
typedef struct
{
	U8	bLength;							//!< ޲Ăł̂̋Lqq̑傫
	U8	bDescriptorType;					//!< ߲ċLqq`
	U8	bEndpointAddress;					//!< ߲Ă̱ڽ
	U8	bmAttributes;						//!< ߲Ă̑
	U16	wMaxPacketSize;						//!< EPɑ΂ő߹ėe
	U8	bInterval;							//!< msłEP߰ݸފԊu
} S_usb_endpoint_descriptor;

//! USBuCLqq
typedef struct
{
	U8	bLength;							//!< ޲Ăł̂̋Lqq̑傫
	U8	bDescriptorType;					//!< uCLqq`
	U16	bscUSB;								//!< Jdl2i10il
	U8	bDeviceClass;						//!< USBɂĊ蓖Ăꂽ׽
	U8	bDeviceSubClass;					//!< USBɂĊ蓖Ăꂽ׽
	U8	bDeviceProtocol;					//!< USBɂĊ蓖ĂꂽK񕄍
	U8	bMaxPacketSize0;					//!< EP0ɑ΂ő߹ėe
	U8	bNumConfigurations;					//!< \Ȍ`Ԑݒ萔
	U8	bReserved;							//!< pɗ\A0łȂ΂Ȃ܂B
} S_usb_device_qualifier_descriptor;

//! USBLqq
typedef struct
{
	U8	bLength;							//!< ޲Ăł̂̋Lqq̑傫
	U8	bDescriptorType;					//!< Lqq`
	U16	wlangid;							//!< ID
} S_usb_language_id;

//_____ USBƎҋLqq __________________________________________________

// usb_st_manufacturer\
typedef struct
{
	U8	bLength;							// ޲Ăł̂̋Lqq̑傫
	U8	bDescriptorType;					// Lqq`
	U16	wstring[USB_MN_LENGTH];				// ƺޕ
} S_usb_manufacturer_string_descriptor;

//_____ USBiLqq ______________________________________________________

// usb_st_product\
typedef struct
{
	U8	bLength;							// ޲Ăł̂̋Lqq̑傫
	U8	bDescriptorType;					// Lqq`
	U16	wstring[USB_PN_LENGTH];				// ƺޕ
} S_usb_product_string_descriptor;

//_____ USBʔԋLqq ______________________________________________________

// usb_st_serial_number\
typedef struct
{
	U8	bLength;							// ޲Ăł̂̋Lqq̑傫
	U8	bDescriptorType;					// Lqq`
	U16	wstring[USB_SN_LENGTH];				// ƺޕ
} S_usb_serial_number;

//_____ USB HIDLqq ______________________________________________________

typedef struct
{
	U8	bLength;							/* ޲Ăł̂̋Lqq̑傫 */
	U8	bDescriptorType;					/* HIDLqq` */
	U16	bscHID;								/* Jdl2i10il */
	U8	bCountryCode;						/* ʰ޳ڕW */
	U8	bNumDescriptors;					/* 㑱HID׽Lqq */
	U8	bRDescriptorType;					/* 񍐋Lqq` */
	U16	wDescriptorLength;					/* 񍐋Lqq̍v */
} S_usb_hid_descriptor;

typedef struct
{
	S_usb_configuration_descriptor cfg_mouse;
	S_usb_interface_descriptor     ifc_mouse;
	S_usb_hid_descriptor           hid_mouse;
	S_usb_endpoint_descriptor      ep1_mouse;
} S_usb_user_configuration_descriptor;

#endif
