//! @file usb_specific_request.c,v
//!
//! 쌠 (c) 2004 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief gpҌĂі߂֐
//!
//! ̧ق͉pɑΉgpҌĂі߂֐܂݂܂B
//!
//! @version 1.3 at90usb128-demo-mouse-1_0_3 $Id: usb_specific_request.c,v 1.3 2006/08/01 14:19:28 rletendu Exp $
//!
//! @todo
//! @bug

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "lib_mcu\usb\usb_drv.h"
#include "usb_descriptors.h"
#include "modules\usb\device_chap9\usb_standard_request.h"
#include "usb_specific_request.h"

//_____ ϸ ________________________________________________________________

//_____ ` _______________________________________________________________

//_____ I錾 ___________________________________________________________

#ifdef AVRGCC
extern PGM_VOID_P pbuffer;
#else
extern U8 code *pbuffer;
#endif
extern U8 data_to_transfer;
extern code S_usb_hid_report_descriptor_mouse usb_hid_report_descriptor_mouse;
extern U16  wInterface;

//_____ 錾 _______________________________________________________________

//! usb_user_read_request(type, request);
//!
//! ̊֐USBvxȂɕWUSBǂݍݗv֐ɂČĂ΂
//! B̊֐͗vꂽTRUEԂ܂B̊֐͗vx
//! ȂꍇFALSEԂ܂B̏ꍇAWUSBǂݍݗv֐ɂĎI
//! STALL޼܂B
//!
//! @param type		bmRequestTypeɑΉ (USBdlB)
//! @param request	bRequestɑΉ (USBdlB)
//!
//! @return TRUE,	vꂽ
//! @return FALSE,	vm̏ꍇ
//!
Bool usb_user_read_request(U8 type, U8 request)
{
	U8 descriptor_type;
	U8 string_type ;

	string_type     = Usb_read_byte();
	descriptor_type = Usb_read_byte();
	switch(request)
	{
		case GET_DESCRIPTOR:
			switch (descriptor_type)
			{
				case REPORT:
					hid_get_report();
					return TRUE;
					break;
				case HID:
					hid_get_hid_descriptor();
					return TRUE;
					break;
				default:
					return FALSE;
					break;
			}
			break;
		case SET_CONFIGURATION:
			switch (descriptor_type)
			{
				case SET_REPORT:
					hid_set_report();
					return TRUE;
					break;
				default:
					return FALSE;
					break;
			}
			break;
		case GET_INTERFACE:
//			usb_hid_set_idle();
			usb_hid_get_interface();
			return TRUE;
			break;
		default:
			return FALSE;
			break;
	}
	return FALSE;
}

//! usb_user_endpoint_init
//!
//! @brief ̊֐ʹ߲Ă`Ԑݒ肵܂B
//!
//! @param conf_nb	USBνĂɂđI΂ꂽ`Ԑݒԍ
//!
//! @return	Ȃ
//!
void usb_user_endpoint_init(U8 conf_nb)
{
	usb_configure_endpoint(EP_MOUSE_IN,		\
						   TYPE_INTERRUPT,	\
						   DIRECTION_IN,	\
						   SIZE_8,			\
						   ONE_BANK,		\
						   NYET_ENABLED);
}

//! usb_user_get_descriptor
//!
//! @brief ̊֐͎gpҏ\̂ő傫߲Ԃ܂B
//!
//! @param type		wValueMSBɑΉ(USBdlB)
//! @param string	wValueLSBɑΉ(USBdlB)
//!
//! @return FALSE,	SʋLqqȂꍇ
//!
Bool usb_user_get_descriptor(U8 type, U8 string)
{
	switch(type)
	{
		case STRING_DESCRIPTOR:
			switch (string)
			{
				case LANG_ID:
					data_to_transfer = sizeof (usb_user_language_id);
					pbuffer = &(usb_user_language_id.bLength);
					return TRUE;
					break;
				case MAN_INDEX:
					data_to_transfer = sizeof (usb_user_manufacturer_string_descriptor);
					pbuffer = &(usb_user_manufacturer_string_descriptor.bLength);
					return TRUE;
					break;
				case PROD_INDEX:
					data_to_transfer = sizeof (usb_user_product_string_descriptor);
					pbuffer = &(usb_user_product_string_descriptor.bLength);
					return TRUE;
					break;
				case SN_INDEX:
					data_to_transfer = sizeof (usb_user_serial_number);
					pbuffer = &(usb_user_serial_number.bLength);
					return TRUE;
					break;
				default:
					return FALSE;
			}
		default:
			return FALSE;
	}
	return FALSE;
}

//! hid_get_report
//!
//! @brief ̊֐HID񍐎擾vǗ܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void hid_get_report(void)
{
	U16 wLength;
	U8  nb_byte;
	bit zlp=0;

	LSB(wInterface)=Usb_read_byte();
	MSB(wInterface)=Usb_read_byte();

	data_to_transfer = sizeof(usb_hid_report_descriptor_mouse);
	pbuffer = &(usb_hid_report_descriptor_mouse.report[0]);

	LSB(wLength) = Usb_read_byte(); 		//!< wLengthǂݍ
	MSB(wLength) = Usb_read_byte();
	Usb_ack_receive_setup();				//!< \ݒ(SETUP)M׸މ

	if (wLength > data_to_transfer)
	{
		if ((data_to_transfer % EP_CONTROL_LENGTH) == 0) { zlp = TRUE; }
		else { zlp = FALSE; }				//!< 0߹Ă̕KvȂ
	}
	else
	{
		data_to_transfer = (U8)wLength;		//!< vꂽް𑗏o
	}

	while((data_to_transfer != 0) && (!Is_usb_receive_out()))
	{
		while(!Is_usb_read_control_enabled());

		nb_byte=0;
		while(data_to_transfer != 0)		//!< Kvȕ܂ްo
		{
			if(nb_byte++==EP_CONTROL_LENGTH)	//!< ߲0̑傫
			{
				break;
			}
#ifndef AVRGCC
			Usb_write_byte(*pbuffer++);
#else // AVRGCCPGMԂւ߲x܂B
#warning with avrgcc assumes devices descriptors are stored in the lower 64Kbytes of on-chip flash memory
			Usb_write_byte(pgm_read_byte_near((unsigned int)pbuffer++));
#endif
			data_to_transfer --;
		}
		Usb_send_control_in();
	}

	Usb_send_control_in();

	if(Is_usb_receive_out()) { Usb_ack_receive_out(); return; }	//!< νĂ̒~
	if(zlp == TRUE)        { Usb_send_control_in(); }

	while(!Is_usb_receive_out());
	Usb_ack_receive_out();
}

//! hid_set_report
//!
//! @brief ̊֐HID񍐐ݒvǗ܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void hid_set_report (void)
{
	Usb_ack_receive_setup();
	Usb_send_control_in();

	while(!Is_usb_receive_out());
	Usb_ack_receive_out();
	Usb_send_control_in();
}

//! usb_hid_set_idle
//!
//! @brief ̊֐HIDِݒvǗ܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void usb_hid_set_idle (void)
{
	U8 dummy;
	dummy = Usb_read_byte();
	dummy = Usb_read_byte();
	LSB(wInterface)=Usb_read_byte();
	MSB(wInterface)=Usb_read_byte();

	Usb_ack_receive_setup();

	Usb_send_control_in();					/* ԒiK0߹Ă𑗏o */
	while(!Is_usb_in_ready());
}

//! usb_hid_get_interface
//!
//! @brief ̊֐HID̪擾vǗ܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void usb_hid_get_interface (void)
{
	U8 dummy;
	dummy = Usb_read_byte();
	dummy = Usb_read_byte();
	LSB(wInterface)=Usb_read_byte();
	MSB(wInterface)=Usb_read_byte();

	Usb_ack_receive_setup();

	Usb_send_control_in();					/* ԒiK0߹Ă𑗏o */
	while(!Is_usb_in_ready());
}

//! hid_get_hid_descriptor
//!
//! @brief ̊֐HID HIDLqq擾vǗ܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void hid_get_hid_descriptor(void)
{
	U16 wLength;
	U8  nb_byte;
	bit zlp=0;

	LSB(wInterface)=Usb_read_byte();
	MSB(wInterface)=Usb_read_byte();

	data_to_transfer = sizeof(usb_conf_desc.hid_mouse);
	pbuffer = &(usb_conf_desc.hid_mouse.bLength);

	LSB(wLength) = Usb_read_byte();			//!< wLengthǂݍ
	MSB(wLength) = Usb_read_byte();
	Usb_ack_receive_setup() ;				//!< \ݒ(SETUP)׸މ

	if (wLength > data_to_transfer)
	{
		if ((data_to_transfer % EP_CONTROL_LENGTH) == 0) { zlp = TRUE; }
		else { zlp = FALSE; }				//!< 0߹Ă̕KvȂ
	}
	else
	{
		data_to_transfer = (U8)wLength;		//!< vꂽ޲Đo
	}

	while((data_to_transfer != 0) && (!Is_usb_receive_out()))
	{
		while(!Is_usb_read_control_enabled());

		nb_byte=0;
		while(data_to_transfer != 0)		//!< Kvȕ܂ްo
		{
			if(nb_byte++==EP_CONTROL_LENGTH)	//!< ߲0̑傫
			{
				break;
			}
#ifndef AVRGCC
			Usb_write_byte(*pbuffer++);
#else // AVRGCCPGMԂւ߲x܂B
#warning with avrgcc assumes devices descriptors are stored in the lower 64Kbytes of on-chip flash memory
			Usb_write_byte(pgm_read_byte_near((unsigned int)pbuffer++));
#endif
			data_to_transfer --;
		}
		Usb_send_control_in();
	}

	Usb_send_control_in();

	if(Is_usb_receive_out()) { Usb_ack_receive_out(); return; }	//!< νĂ̒~
	if(zlp == TRUE)        { Usb_send_control_in(); }

	while(!Is_usb_receive_out());
	Usb_ack_receive_out();
}
